import React from 'react';
import type { TreeProps } from 'rlj-design';
export interface BaseTreeProps extends Omit<TreeProps, 'onCheck'> {
    showStrictlyTip?: boolean;
    strictlyTip?: React.ReactNode;
    checkStrictly?: boolean;
    onCheck?: (checkedKeysValue: React.Key[], info: any, checkedKeysMap?: Map<React.Key, BaseTreeNodeProps> | boolean) => void;
    checkedKeysMap?: Map<React.Key, BaseTreeNodeProps>;
}
export interface BaseTreeNodeProps {
    emp?: {
        empId: string;
        name: string;
        orgChain: string;
    };
    org?: {
        name: string;
        haveChildren: boolean;
        orgChain: string;
        orgId: string;
        parentOrgId: string;
        syncStatus: boolean;
    };
    empName?: string;
    orgName?: string;
    empId?: string;
    orgId?: string;
    nodeType: number;
    key?: string;
    title?: string;
    children?: BaseTreeNodeProps[];
    orgChain?: string;
    invalid?: boolean;
    loseEffect?: boolean;
    tip?: string;
    parentOrgId?: string;
}
