/// <reference types="react" />
import type { FormListFieldData, DrawerProps } from 'rlj-design';
import type { DPPickerProps } from '../DPPicker/interface';
import type { CCProps } from '../CostCenterPicker/interface';
export interface SelectionItemType {
    label: string;
    value: string;
    markValue?: string;
    status?: string;
}
export declare type SelectionType = SelectionItemType[];
export interface ScopeFieldsType {
    groupName: string;
    groupId: string;
    fields: {
        fieldId: string;
        fieldName: string;
        fieldType: 'org' | 'object' | 'string' | 'selection' | 'emp';
        selection: SelectionType | [] | null;
        status: 'normal' | 'stop';
    }[];
}
export interface ScopeItemType {
    fields: {
        option: SelectionItemType & {
            fieldId: string;
            fieldName: string;
            fieldType: string;
        };
        value: SelectionType | string[];
    }[];
}
export interface ScopeValueProps {
    item: FormListFieldData;
    selected: string[];
    setSelected: (selected: string[]) => void;
    index: number;
    needShowSelectEmp?: boolean;
}
export declare type CheckedDataType = ScopeFieldsType['fields'][0] & SelectionItemType;
export interface ConditionSettingProps {
    /** 按钮文案，默认文案"添加规则" */
    btnText?: React.ReactNode;
    /** 自定义条件选择按钮 */
    btnRender?: React.ReactNode;
    /** 设置条件选择组件的样式名 */
    className?: string;
    /** 抽屉属性，参考https://www.renlijia.com/azir/docs/index.html#/components/rlj-design/f-callback/drawer#api-%E9%BB%98%E8%AE%A4 */
    drawerProps?: DrawerProps;
    /** 自定义内容展示渲染 */
    detailRender?: React.ReactNode;
    /** 范围字段分组 */
    scopeFields: ScopeFieldsType[];
    /** 默认值 */
    value?: ScopeItemType[];
    /** 选人选部门组件props参数 */
    DDPickerProps?: Partial<DPPickerProps>;
    /** 成本中心组件props参数 */
    CCPickerProps?: Partial<CCProps>;
    /** 需要展示选择人员按钮 */
    needShowSelectEmp?: boolean;
    /** 修改值后的监听 */
    onChange?: (value: ScopeItemType[]) => void;
}
