import React from 'react';
import { PREFIX_CLS } from "../constants/dictionary";
import { Icon, Button, Typography, Divider, Tooltip } from 'rlj-design';
import HighLight from "../HighLight";
import "./style/leftContain.less";
import { useStoreContext } from "./hooks/useStoreContext";
var Text = Typography.Text,
    TextOverFlow = Typography.TextOverFlow;
var prefixCls = "".concat(PREFIX_CLS, "-CostCenterPicker-listContainWrap");

var LeftContain = function LeftContain(props) {
  var item = props.item,
      canChange = props.canChange,
      isSelect = props.isSelect,
      disabled = props.disabled;

  var _useStoreContext = useStoreContext(),
      searchValue = _useStoreContext.searchValue,
      recurse = _useStoreContext.recurse,
      getList = _useStoreContext.getList,
      setBreadcrumbList = _useStoreContext.setBreadcrumbList,
      breadcrumbList = _useStoreContext.breadcrumbList;

  var disabledSelect = isSelect && recurse || disabled; // 所有禁用状态

  var leftIcon = disabled ? 'disabledIcon' : 'leftIcon';
  var searchIcon = disabled ? 'disabledSearchIcon' : 'searchIcon';
  var listText = "".concat(prefixCls, "-listText");
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls)
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(listText)
  }, /*#__PURE__*/React.createElement(Icon, {
    type: item.iconType,
    style: {
      borderRadius: 4,
      color: disabled ? '#99b9f2' : '#0050de'
    },
    className: canChange ? "".concat(listText, "-").concat(searchIcon) : "".concat(listText, "-").concat(leftIcon)
  }), !canChange ? /*#__PURE__*/React.createElement("span", {
    className: "".concat(listText, "-listNameWrap")
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(listText, "-deptNameWraps")
  }, /*#__PURE__*/React.createElement(TextOverFlow, null, item.label))) : /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-listTextWrap")
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      display: 'flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React.createElement(Text, {
    className: "".concat(prefixCls, "-listTextWrap-deptName"),
    style: disabled ? {
      color: '#b6b6ba'
    } : {},
    ellipsis: {
      tooltip: {
        label: item.label
      }
    }
  }, /*#__PURE__*/React.createElement(HighLight, {
    highLightText: searchValue
  }, item.label || '')), /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-listTextWrap-codeWrap")
  }, /*#__PURE__*/React.createElement(Tooltip, {
    placement: "top",
    title: disabled ? '' : item.code
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-listTextWrap-code")
  }, item.code)))), /*#__PURE__*/React.createElement(Text, {
    className: "".concat(prefixCls, "-listTextWrap-chain"),
    style: disabled ? {
      color: '#b6b6ba'
    } : {},
    ellipsis: {
      tooltip: {
        label: item.chain
      }
    }
  }, /*#__PURE__*/React.createElement(HighLight, {
    highLightText: searchValue
  }, item.chain || '-')))), !canChange && item.haveChildren && !searchValue && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-recuseBtnWap")
  }, /*#__PURE__*/React.createElement(Divider, {
    type: "vertical"
  }), /*#__PURE__*/React.createElement(Button, {
    disabled: disabledSelect,
    type: "link",
    noPadding: true,
    style: {
      marginLeft: 4
    },
    className: disabledSelect ? "".concat(prefixCls, "-recuseBtnWap-recuseBtn") : "".concat(prefixCls, "-recuseBtnWap-Btn"),
    onClick: function onClick(e) {
      e.preventDefault();
      setBreadcrumbList(item.value === '1' ? [] : breadcrumbList.concat(item));
      getList(item.value);
    }
  }, "\u4E0B\u7EA7"))));
};

export default LeftContain;