function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo, useState } from 'react';
import { Input, Icon, Typography, Checkbox, Radio, Tooltip, Empty, Form, Dropdown } from 'rlj-design';
import "./style/index.less";
import { PREFIX_CLS } from "../constants/dictionary";
import { useDebounceFn } from 'ahooks';
import { STATIC } from "./common";
import LeftContain from "./leftContain";
import { useStoreContext } from "./hooks/useStoreContext";
import { FixedSizeList } from 'react-window';
import ResizeObserver from 'rc-resize-observer';
var FillSearch = Input.FillSearch;
var LongText = Typography.LongText;
var prefixCls = "".concat(PREFIX_CLS, "-CostCenterPicker");

var LeftPart = function LeftPart() {
  var _chain$slice, _chain;

  var _useStoreContext = useStoreContext(),
      searchPlaceholder = _useStoreContext.searchPlaceholder,
      multiple = _useStoreContext.multiple,
      rootNode = _useStoreContext.rootNode,
      breadcrumbList = _useStoreContext.breadcrumbList,
      searchData = _useStoreContext.searchData,
      getList = _useStoreContext.getList,
      selectKeys = _useStoreContext.selectKeys,
      selectValue = _useStoreContext.selectValue,
      setSelectValue = _useStoreContext.setSelectValue,
      leftPartList = _useStoreContext.leftPartList,
      leftPartSearch = _useStoreContext.leftPartSearch,
      setSearchValue = _useStoreContext.setSearchValue,
      setBreadcrumbList = _useStoreContext.setBreadcrumbList,
      searchValue = _useStoreContext.searchValue,
      adjustSelectValue = _useStoreContext.adjustSelectValue,
      searchLoading = _useStoreContext.searchLoading,
      showMore = _useStoreContext.showMore,
      isShowStop = _useStoreContext.isShowStop,
      setIsShowStop = _useStoreContext.setIsShowStop,
      isFirstLoad = _useStoreContext.isFirstLoad;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isActive = _useState2[0],
      setIsActive = _useState2[1];

  var _useMemo = useMemo(function () {
    var res = [{
      label: '成本中心',
      value: '0'
    }].concat(_toConsumableArray(rootNode), _toConsumableArray(breadcrumbList));
    return [res, res.length];
  }, [breadcrumbList, rootNode]),
      _useMemo2 = _slicedToArray(_useMemo, 2),
      chain = _useMemo2[0],
      chainLen = _useMemo2[1]; // 搜索接口


  var _useDebounceFn = useDebounceFn(function (searchKey) {
    setSearchValue(searchKey);

    if (searchKey) {
      searchData({
        searchKey: searchKey
      });
    }
  }, {
    wait: 600
  }),
      run = _useDebounceFn.run; // 获取面包屑的index


  var getIndex = function getIndex(item, index) {
    var breadIndex = breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.findIndex(function (v) {
      return v.value === item.value;
    });
    setBreadcrumbList(breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.slice(0, breadIndex + 1));
    getList(item.value);
  }; // 全选


  var onChangeAll = function onChangeAll(checked) {
    if (checked) {
      // 切换上下级的时候，全选中的id，去掉重复的id
      var newData = leftPartList.filter(function (v) {
        return !v.disabled && !selectKeys.includes(v.value);
      });
      setSelectValue([].concat(_toConsumableArray(selectValue), _toConsumableArray(newData)));
    } else {
      // 取消全选的时候，当前页的id，全部删掉
      var _newData = selectValue.filter(function (v) {
        return !leftPartList.find(function (item) {
          return item.value === v.value;
        });
      });

      setSelectValue(_newData);
    }
  };

  var rowItem = function rowItem(_ref) {
    var index = _ref.index,
        style = _ref.style;
    var item = !!searchValue ? leftPartSearch[index] : leftPartList[index];
    var value = item.value,
        disabled = item.disabled,
        tooltip = item.tooltip;
    var isSelect = selectKeys.includes(value); // 是否选中状态

    var canChange = !searchLoading && !!searchValue;
    var leftListDom = /*#__PURE__*/React.createElement(LeftContain, {
      item: item,
      canChange: canChange,
      disabled: disabled,
      isSelect: isSelect
    });
    return /*#__PURE__*/React.createElement("div", {
      style: _objectSpread(_objectSpread({}, style), {}, {
        paddingRight: 16
      })
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        height: canChange ? 48 : 40,
        lineHeight: canChange ? '48px' : '40px'
      },
      className: "".concat(prefixCls, "-leftPart-leftContain-leftListLi"),
      key: index
    }, /*#__PURE__*/React.createElement(Tooltip, {
      placement: "topLeft",
      title: disabled ? tooltip : '',
      overlayClassName: "".concat(prefixCls, "-tooltipStyle")
    }, multiple ?
    /*#__PURE__*/
    // 选择部门和人
    React.createElement(Checkbox, {
      checked: isSelect,
      onChange: function onChange(e) {
        return adjustSelectValue(e.target.checked, item, 'checkbox');
      },
      disabled: disabled
    }, leftListDom) : /*#__PURE__*/React.createElement(Radio, {
      style: {
        lineHeight: canChange ? '48px' : '40px'
      },
      checked: isSelect,
      onChange: function onChange() {
        return adjustSelectValue(true, item, 'radio');
      },
      disabled: disabled
    }, leftListDom))));
  };

  var _useMemo3 = useMemo(function () {
    // 获取全选
    var initLeftIdList = [];
    leftPartList === null || leftPartList === void 0 ? void 0 : leftPartList.forEach(function (item) {
      if (!item.disabled) {
        initLeftIdList.push(item.value);
      }
    }); // 全部选中

    var allSelect = initLeftIdList.length !== 0 && initLeftIdList.every(function (item) {
      return selectKeys.includes(item);
    }); // 部分选中

    var partSelect = initLeftIdList.some(function (item) {
      return selectKeys.includes(item);
    });
    return [allSelect, allSelect ? false : partSelect];
  }, [selectKeys, leftPartList]),
      _useMemo4 = _slicedToArray(_useMemo3, 2),
      checked = _useMemo4[0],
      indeterminate = _useMemo4[1];

  var items = [{
    key: '1',
    label: isShowStop ? /*#__PURE__*/React.createElement("a", {
      onClick: function onClick() {
        setIsActive(false);
        setIsShowStop(false);
      }
    }, "\u9690\u85CF\u5DF2\u505C\u7528\u6210\u672C\u4E2D\u5FC3") : /*#__PURE__*/React.createElement("a", {
      onClick: function onClick() {
        setIsActive(false);
        setIsShowStop(true);
      }
    }, "\u5C55\u793A\u5DF2\u505C\u7528\u6210\u672C\u4E2D\u5FC3")
  }];
  if (isFirstLoad) return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart")
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart")
  }, /*#__PURE__*/React.createElement(ResizeObserver, null, /*#__PURE__*/React.createElement("div", {
    id: "leftPart"
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart-topSearchWrap")
  }, /*#__PURE__*/React.createElement(Form, {
    className: "".concat(prefixCls, "-leftPart-searchInputWrap"),
    form: form,
    onValuesChange: function onValuesChange(changedValues) {
      run(changedValues.searchValue);
    }
  }, /*#__PURE__*/React.createElement(Form.Item, {
    name: "searchValue"
  }, /*#__PURE__*/React.createElement(FillSearch, {
    className: "".concat(prefixCls, "-inputSearch"),
    placeholder: searchPlaceholder || STATIC.common.searchPlaceholder
  }))), showMore && /*#__PURE__*/React.createElement(Dropdown, {
    menu: {
      items: items
    },
    placement: "bottomRight",
    trigger: ['click'],
    onOpenChange: function onOpenChange(e) {
      return setIsActive(e);
    }
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-moreBtn"),
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }, "\u66F4\u591A", /*#__PURE__*/React.createElement(Icon, {
    type: "downArrow",
    rotate: isActive ? 180 : 0,
    style: {
      marginLeft: 2
    }
  })))), !searchValue && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-breadcrumbWrap")
  }, chain === null || chain === void 0 ? void 0 : (_chain$slice = chain.slice(0, chainLen - 1)) === null || _chain$slice === void 0 ? void 0 : _chain$slice.map(function (item, index) {
    return /*#__PURE__*/React.createElement("span", {
      key: index,
      onClick: function onClick() {
        return getIndex(item, index);
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-breadcrumbWrap-brandName")
    }, /*#__PURE__*/React.createElement(LongText, {
      length: 7,
      text: item.label
    })), /*#__PURE__*/React.createElement(Icon, {
      type: "rightArrow"
    }));
  }), /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-breadcrumbWrap-lastText")
  }, /*#__PURE__*/React.createElement(LongText, {
    length: 7,
    text: (_chain = chain[chainLen - 1]) === null || _chain === void 0 ? void 0 : _chain.label
  }))), multiple && !searchValue && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-checkAll")
  }, /*#__PURE__*/React.createElement(Checkbox, {
    onChange: function onChange(e) {
      return onChangeAll(e.target.checked);
    },
    checked: checked,
    indeterminate: indeterminate
  }, "\u5168\u90E8")))), /*#__PURE__*/React.createElement(React.Fragment, null, searchValue && !leftPartSearch.length ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart-noDataWrap")
  }, /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: "\u641C\u7D22\u65E0\u7ED3\u679C"
  })) : !searchValue && !leftPartList.length ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart-noDataWrap"),
    style: {
      margin: '136px auto'
    }
  }, /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: "\u6682\u65E0\u6210\u672C\u4E2D\u5FC3"
  })) : /*#__PURE__*/React.createElement("div", {
    id: "leftContain",
    className: "".concat(prefixCls, "-leftPart-leftContain")
  }, /*#__PURE__*/React.createElement(FixedSizeList, {
    width: '100%',
    height: searchValue ? 405 : 375,
    itemSize: !searchValue ? 40 : 48,
    itemCount: (!!searchValue ? leftPartSearch : leftPartList).length
  }, rowItem))));
};

export default LeftPart;