import React, { useMemo } from 'react';
import { Button, Icon, Typography } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import { STATIC } from "./common";
import { useStoreContext } from "./hooks/useStoreContext";
import ShowTag from "./showTag";
import "./style/rightPart.less";
var prefixCls = "".concat(PREFIX_CLS, "-CostCenterPicker");
var TextOverFlow = Typography.TextOverFlow;

var RightPart = function RightPart() {
  var _useStoreContext = useStoreContext(),
      selectKeys = _useStoreContext.selectKeys,
      setSelectValue = _useStoreContext.setSelectValue,
      selectValue = _useStoreContext.selectValue,
      adjustSelectValue = _useStoreContext.adjustSelectValue; // 维护选中的id值，最后处理值


  var finalSelectList = useMemo(function () {
    return selectKeys.filter(function (item) {
      return !!item;
    });
  }, [selectKeys]);

  var showDom = function showDom(width, text, className) {
    return /*#__PURE__*/React.createElement("span", {
      style: {
        maxWidth: width
      },
      className: "".concat(prefixCls, "-rightPart-").concat(className)
    }, /*#__PURE__*/React.createElement(TextOverFlow, {
      width: "100%"
    }, text));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart-showClearButton")
  }, /*#__PURE__*/React.createElement("span", null, STATIC.common.rightTitle, "\xB7", finalSelectList.length), /*#__PURE__*/React.createElement(Button, {
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "delete"
    }),
    onClick: function onClick() {
      return setSelectValue([]);
    }
  }, "\u6E05\u9664")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart-rightContainWrap")
  }, selectValue === null || selectValue === void 0 ? void 0 : selectValue.map(function (item) {
    var showTag = item.status === 'disable';
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightContainWrap-rightListLi"),
      key: item.value
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightListWrap")
    }, /*#__PURE__*/React.createElement(Icon, {
      type: item.iconType,
      style: {
        borderRadius: 4
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightListWrap-topWrap")
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-rightPart-infoWrap")
    }, showDom(showTag ? 160 : 180, item.label || '-', 'infoWrap-name'), showTag && /*#__PURE__*/React.createElement(ShowTag, {
      item: item
    }), showDom(showTag ? 40 : 90, item.code || '', 'infoWrap-code')), showDom(224, item.chain || '-', 'orgChain'))), /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      className: "".concat(prefixCls, "-rightPart-rightClose"),
      onClick: function onClick() {
        return adjustSelectValue(false, item, 'checkbox');
      }
    })));
  })));
};

export default RightPart;