/// <reference types="react" />
import type { SelectProps } from 'rlj-design';
export interface BaseNodeProps {
    emp?: {
        empId: string;
        name: string;
        orgChain: string;
    };
    org?: {
        name: string;
        haveChildren: boolean;
        orgChain: string;
        orgId: string;
        parentOrgId: string;
        syncStatus: boolean;
    };
    empName?: string;
    orgName?: string;
    empId?: string;
    orgId?: string;
    nodeType: number;
    key?: string;
    title?: string;
    children?: BaseNodeProps[];
    orgChain?: string;
    invalid?: boolean;
    loseEffect?: boolean;
    tip?: string;
    parentOrgId?: string;
}
export interface DPPickerProps {
    /** 弹窗的显隐*/
    open: boolean;
    /** 是否多选*/
    multiple?: boolean;
    /** 左侧数据接口*/
    selectDept: Function;
    /** 组件类型，是选择组织，人员还是组织和人员*/
    type: 'dept' | 'person' | 'deptPerson';
    /** 指定当前选中的条目，多选时为一个数组。 */
    value?: SelectProps['value'];
    /** 点击确定回调*/
    onOk: (param: {
        label: string;
        value: string;
    }[], keyList: (string | number)[], keyMap: Map<React.Key, BaseNodeProps>) => void;
    /** 点击取消回调*/
    onCancel: () => void;
    /** 搜索框默认文字*/
    searchPlaceholder?: string;
    /**自定义请求参数*/
    defaultParams?: {
        [key: string]: any;
    };
    /**是否包含下级*/
    recurse?: boolean;
    /**搜索部门接口*/
    searchDeptChain: Function;
    /**搜索人员接口*/
    searchPersonChain: Function;
    /** 禁止勾选节点 */
    disableNode?: {
        [key: string]: string;
    };
    /** 自定义数据处理函数 */
    customDataHandle?: any;
    /** 标题 */
    title?: string;
    /**是否展示更多按钮*/
    showMore?: boolean;
}
export interface BrandCrumbType {
    orgId: string;
    deptName: string;
}
export interface DataListType {
    orgId: string;
    empId: string;
    deptName: string;
    haveChildren: boolean;
    nodeType: number;
    orgChain: string;
    isPower: boolean;
    code: string;
    iconType: string;
    children: DataListType[];
    disabled?: boolean;
    tooltip?: string;
}
export interface ResultType {
    orgId: string;
    empId: string;
    deptName: string;
    nodeType: number;
}
