function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { Input, Icon, Typography, Checkbox, Radio, Tooltip, Empty, Form, Dropdown } from 'rlj-design';
import "./style/index.less";
import { PREFIX_CLS } from "../constants/dictionary";
import { useDebounceFn } from 'ahooks';
import { getHandleData, STATIC, showDisabledParams, defaultSelectParams } from "./common";
import LeftContain from "./leftContain";
import { useStoreContext } from "./hooks/useStoreContext";
import { FixedSizeList } from 'react-window';
import ResizeObserver from 'rc-resize-observer';
var FillSearch = Input.FillSearch;
var LongText = Typography.LongText;
var prefixCls = "".concat(PREFIX_CLS, "-DPPicker");

var LeftPart = function LeftPart() {
  var _breadcrumbList$slice, _breadcrumbList;

  var _useStoreContext = useStoreContext(),
      type = _useStoreContext.type,
      searchPlaceholder = _useStoreContext.searchPlaceholder,
      multiple = _useStoreContext.multiple,
      disableNode = _useStoreContext.disableNode,
      breadcrumbList = _useStoreContext.breadcrumbList,
      setLeftPartList = _useStoreContext.setLeftPartList,
      searchData = _useStoreContext.searchData,
      getList = _useStoreContext.getList,
      listMap = _useStoreContext.listMap,
      setSelectKeys = _useStoreContext.setSelectKeys,
      leftPartList = _useStoreContext.leftPartList,
      setSearchValue = _useStoreContext.setSearchValue,
      setBreadcrumbList = _useStoreContext.setBreadcrumbList,
      selectKeys = _useStoreContext.selectKeys,
      searchValue = _useStoreContext.searchValue,
      isCheck = _useStoreContext.isCheck,
      getSelectItem = _useStoreContext.getSelectItem,
      searchLoading = _useStoreContext.searchLoading,
      showMore = _useStoreContext.showMore,
      setShowParams = _useStoreContext.setShowParams,
      setIsChangeParams = _useStoreContext.setIsChangeParams;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      showDisable = _useState2[0],
      SetShowDisable = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isActive = _useState4[0],
      setIsActive = _useState4[1]; // 搜索接口


  var _useDebounceFn = useDebounceFn(function (searchKey) {
    setSearchValue(searchKey);

    if (searchKey) {
      searchData({
        searchKey: searchKey
      }).then(function (nodeList) {
        return setLeftPartList(nodeList);
      });
    } else {
      // 如果搜索值为空，直接回到进入搜索前的页面
      var id = breadcrumbList[breadcrumbList.length - 1].orgId;
      getList(id);
    }
  }, {
    wait: 600
  }),
      run = _useDebounceFn.run; // 获取面包屑的index


  var getIndex = function getIndex(item) {
    var breadIndex = breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.findIndex(function (v) {
      return v.orgId === item.orgId;
    });
    setBreadcrumbList(breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.slice(0, breadIndex + 1)); // 如果点击”组织架构“，这里需要调接口，获取组织的名称
    // 这里兼容后端返回的俩种格式，如果全量返回数据，就展示每个item.children,如果是需要调用接口，则走原来的接口数据

    if (item.orgId === '0') {
      getList('0');
    } else {
      if (item.children) {
        var newArr = getHandleData(item.children);
        setLeftPartList(newArr);
      } else {
        getList(item.orgId);
      }
    }
  }; // 单选onChange


  var radioChange = function radioChange(item) {
    setSelectKeys([item.empId || item.orgId]);
    listMap.set(item.empId || item.orgId, item);
  }; // 全选


  var onChangeAll = function onChangeAll(e) {
    var keyList = []; // 如果是选人部门，过滤掉组织

    leftPartList.map(function (item) {
      var key = item.orgId || item.empId; // 过滤掉无权限的人员或部门

      if (!item.disabled && !(disableNode !== null && disableNode !== void 0 && disableNode[key])) {
        keyList.push(type !== 'person' && item.nodeType === 2 ? item.orgId : item.empId);
        listMap.set(key, item);
      }
    });

    if (e.target.checked) {
      // 切换上下级的时候，全选中的id，去掉重复的id
      var allSelectList = new Set([].concat(_toConsumableArray(selectKeys), keyList));
      setSelectKeys(_toConsumableArray(allSelectList));
    } else {
      // 取消全选的时候，当前页的id，全部删掉
      var newSelectList = [];
      selectKeys.forEach(function (item) {
        if (!keyList.includes(item)) {
          newSelectList.push(item);
        }
      });
      setSelectKeys(newSelectList);
    }
  };

  var rowItem = function rowItem(_ref) {
    var index = _ref.index,
        style = _ref.style;
    var item = leftPartList[index];
    var nodeType = item.nodeType,
        orgId = item.orgId,
        empId = item.empId,
        disabled = item.disabled,
        tooltip = item.tooltip;
    var isDisabled = disabled || !!(disableNode !== null && disableNode !== void 0 && disableNode[orgId || empId]); // 是否禁止选择

    var isSelect = selectKeys.includes(orgId || empId); // 是否选中状态

    var canChange = !searchLoading && !!searchValue;
    var leftListDom = /*#__PURE__*/React.createElement(LeftContain, {
      item: item,
      canChange: canChange,
      isDisabled: isDisabled,
      isSelect: isSelect
    });
    return /*#__PURE__*/React.createElement("div", {
      style: _objectSpread(_objectSpread({}, style), {}, {
        paddingRight: 16
      })
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        height: canChange ? 48 : 40,
        lineHeight: canChange ? '48px' : '40px'
      },
      className: "".concat(prefixCls, "-leftPart-leftContain-leftListLi"),
      key: index
    }, /*#__PURE__*/React.createElement(Tooltip, {
      placement: "topLeft",
      title: isDisabled ? tooltip || (disableNode === null || disableNode === void 0 ? void 0 : disableNode[empId || orgId]) : '',
      overlayClassName: "".concat(prefixCls, "-tooltipStyle")
    }, type === 'person' && nodeType === 1 || type !== 'person' ? multiple ?
    /*#__PURE__*/
    // 选择部门和人
    React.createElement(Checkbox, {
      checked: isSelect,
      onChange: function onChange(e) {
        getSelectItem(e, empId || orgId, item);
      },
      disabled: isDisabled
    }, leftListDom) : /*#__PURE__*/React.createElement(Radio, {
      style: {
        lineHeight: canChange ? '48px' : '40px'
      },
      checked: isSelect,
      onChange: function onChange() {
        radioChange(item);
      },
      disabled: isDisabled
    }, leftListDom) : /*#__PURE__*/React.createElement("span", {
      style: {
        paddingTop: 8
      }
    }, leftListDom))));
  };

  var items = [{
    key: '1',
    label: showDisable ? /*#__PURE__*/React.createElement("a", {
      onClick: function onClick() {
        SetShowDisable(!showDisable);
        setShowParams(showDisabledParams);
        setIsActive(false);
      }
    }, type === 'dept' ? '展示已停用组织' : '展示已离职人员') : /*#__PURE__*/React.createElement("a", {
      onClick: function onClick() {
        SetShowDisable(!showDisable);
        setShowParams(defaultSelectParams);
        setIsActive(false);
      }
    }, type === 'dept' ? '隐藏已停用组织' : '隐藏已离职人员')
  }];
  var scrollHeight = multiple ? searchValue ? 364 : 334 : searchValue ? 404 : 374;
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart")
  }, /*#__PURE__*/React.createElement(ResizeObserver, null, /*#__PURE__*/React.createElement("div", {
    id: "leftPart"
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart-topSearchWrap")
  }, /*#__PURE__*/React.createElement(Form, {
    className: "".concat(prefixCls, "-leftPart-searchInputWrap"),
    form: form,
    onValuesChange: function onValuesChange(changedValues) {
      run(changedValues.searchValue);
    }
  }, /*#__PURE__*/React.createElement(Form.Item, {
    name: "searchValue"
  }, /*#__PURE__*/React.createElement(FillSearch, {
    className: "".concat(prefixCls, "-inputSearch"),
    placeholder: searchPlaceholder || STATIC[type].searchPlaceholder
  }))), showMore && /*#__PURE__*/React.createElement(Dropdown, {
    menu: {
      items: items
    },
    placement: "bottomRight",
    trigger: ['click'],
    onOpenChange: function onOpenChange() {
      setIsActive(true);
    }
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-moreBtn"),
    onClick: function onClick(e) {
      setIsChangeParams(true);
      e.stopPropagation();
    }
  }, "\u66F4\u591A", /*#__PURE__*/React.createElement(Icon, {
    type: "downArrow",
    rotate: isActive ? 180 : 0,
    style: {
      marginLeft: 2
    }
  })))), !searchValue && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-breadcrumbWrap")
  }, breadcrumbList === null || breadcrumbList === void 0 ? void 0 : (_breadcrumbList$slice = breadcrumbList.slice(0, (breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.length) - 1)) === null || _breadcrumbList$slice === void 0 ? void 0 : _breadcrumbList$slice.map(function (item, index) {
    return /*#__PURE__*/React.createElement("span", {
      key: index,
      onClick: function onClick() {
        return getIndex(item);
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-breadcrumbWrap-brandName")
    }, /*#__PURE__*/React.createElement(LongText, {
      length: 7,
      text: item.deptName
    })), /*#__PURE__*/React.createElement(Icon, {
      type: "rightArrow"
    }));
  }), /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-breadcrumbWrap-lastText")
  }, (_breadcrumbList = breadcrumbList[(breadcrumbList === null || breadcrumbList === void 0 ? void 0 : breadcrumbList.length) - 1]) === null || _breadcrumbList === void 0 ? void 0 : _breadcrumbList.deptName)), multiple && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-checkAll")
  }, /*#__PURE__*/React.createElement(Checkbox, {
    onChange: onChangeAll,
    checked: isCheck.check,
    indeterminate: isCheck.indeterminate
  }, "\u5168\u90E8")))), searchValue && leftPartList.length === 0 ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-leftPart-noDataWrap")
  }, /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: "\u641C\u7D22\u65E0\u7ED3\u679C"
  })) : /*#__PURE__*/React.createElement("div", {
    id: "leftContain",
    className: "".concat(prefixCls, "-leftPart-leftContain")
  }, /*#__PURE__*/React.createElement(FixedSizeList, {
    width: '100%',
    height: scrollHeight,
    itemSize: !searchValue ? 40 : 48,
    itemCount: leftPartList.length
  }, rowItem)));
};

export default LeftPart;