import React, { useMemo } from 'react';
import { Button, Icon, Typography } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import { STATIC } from "./common";
import { useStoreContext } from "./hooks/useStoreContext";
import ShowTag from "./showTag";
import "./style/rightPart.less";
var prefixCls = "".concat(PREFIX_CLS, "-DPPicker");
var TextOverFlow = Typography.TextOverFlow;

var RightPart = function RightPart() {
  var _useStoreContext = useStoreContext(),
      type = _useStoreContext.type,
      selectKeys = _useStoreContext.selectKeys,
      listMap = _useStoreContext.listMap,
      setSelectKeys = _useStoreContext.setSelectKeys,
      getSelectItem = _useStoreContext.getSelectItem; // 维护选中的id值，最后处理值


  var finalSelectList = useMemo(function () {
    if (type !== 'deptPerson') return selectKeys.filter(function (item) {
      return !!item;
    });
    var deptList = [];
    var personList = [];
    selectKeys.forEach(function (key) {
      if (key) {
        listMap.get(key).nodeType === 2 ? deptList.push(key) : personList.push(key);
      }
    });
    return deptList.concat(personList);
  }, [selectKeys]);

  var showDom = function showDom(width, text, className) {
    return /*#__PURE__*/React.createElement("span", {
      style: {
        maxWidth: width
      },
      className: "".concat(prefixCls, "-rightPart-").concat(className)
    }, /*#__PURE__*/React.createElement(TextOverFlow, {
      width: "100%"
    }, text));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart-showClearButton")
  }, /*#__PURE__*/React.createElement("span", null, STATIC[type].rightTitle, "\xB7", finalSelectList.length), /*#__PURE__*/React.createElement(Button, {
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "delete"
    }),
    onClick: function onClick() {
      setSelectKeys([]);
    }
  }, "\u6E05\u9664")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-rightPart-rightContainWrap")
  }, finalSelectList === null || finalSelectList === void 0 ? void 0 : finalSelectList.map(function (key) {
    var _ref = listMap.get(key) || {},
        nodeType = _ref.nodeType,
        deptName = _ref.deptName,
        orgChain = _ref.orgChain,
        empId = _ref.empId,
        orgId = _ref.orgId,
        code = _ref.code,
        iconType = _ref.iconType,
        employeeNumber = _ref.employeeNumber,
        tagStatus = _ref.tagStatus;

    var showTag = tagStatus === 'quitted' || tagStatus === 'disable';
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightContainWrap-rightListLi"),
      key: key
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightListWrap")
    }, /*#__PURE__*/React.createElement(Icon, {
      type: iconType,
      style: {
        borderRadius: nodeType === 1 ? '50%' : 4
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-rightPart-rightListWrap-topWrap")
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-rightPart-infoWrap")
    }, showDom(showTag ? 160 : 180, deptName || '-', 'infoWrap-name'), showTag && /*#__PURE__*/React.createElement(ShowTag, {
      item: listMap.get(key) || {}
    }), showDom(showTag ? 40 : 90, code || employeeNumber, 'infoWrap-code')), showDom(224, orgChain || '-', 'orgChain'))), /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      className: "".concat(prefixCls, "-rightPart-rightClose"),
      onClick: function onClick(e) {
        return getSelectItem(e, empId || orgId, listMap.get(key) || {});
      }
    })));
  })));
};

export default RightPart;