function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import classnames from 'classnames';
import { Spin } from 'rlj-design';
import { FieldMultipleCheckbox } from "./components/FieldMultipleCheckbox";
import { FieldSingleCheckbox } from "./components/FieldSingleCheckbox";
import { useStoreContext } from "./hooks";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/fieldCheckbox.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldCheckbox");

var FieldCheckbox = function FieldCheckbox(props) {
  var isCheckboxGroup = props.isCheckboxGroup,
      header = props.header,
      className = props.className,
      style = props.style;

  var _useStoreContext = useStoreContext(),
      fieldDragWidth = _useStoreContext.fieldDragWidth,
      groupSort = _useStoreContext.groupSort;

  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, className),
    style: _objectSpread({
      width: "calc(100% - ".concat(fieldDragWidth, "px)")
    }, style)
  }, /*#__PURE__*/React.createElement(Spin, {
    spinning: groupSort || false,
    indicator: /*#__PURE__*/React.createElement(React.Fragment, null)
  }, header !== undefined ? header : /*#__PURE__*/React.createElement("p", null, "\u9009\u62E9\u9700\u8981\u663E\u793A\u7684\u8868\u5934\u5B57\u6BB5"), isCheckboxGroup ? /*#__PURE__*/React.createElement(FieldMultipleCheckbox, null) : /*#__PURE__*/React.createElement(FieldSingleCheckbox, null)));
};

export default FieldCheckbox;