function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect } from 'react';
import { DndProvider } from 'react-dnd';
import TagItem, { moveTagItem } from "./TagItem";
import { useStoreContext } from "../hooks";
import { HTML5Backend } from 'react-dnd-html5-backend';
import { PREFIX_CLS } from "../../constants/dictionary";
import "../style/fieldDrag.less";
export var FieldSingleDrag = function FieldSingleDrag() {
  var prefixCls = "".concat(PREFIX_CLS, "-fieldSingleDrag");

  var _useStoreContext = useStoreContext(),
      defaultSelectFields = _useStoreContext.defaultSelectFields,
      selectAllFields = _useStoreContext.selectAllFields,
      setCheckedValueMap = _useStoreContext.setCheckedValueMap,
      checkedValueMap = _useStoreContext.checkedValueMap;

  useEffect(function () {
    if (!defaultSelectFields) return;
    var temp = defaultSelectFields.map(function (_ref) {
      var fieldId = _ref.fieldId;
      return fieldId;
    });
    checkedValueMap.set('single', temp);
    setCheckedValueMap(new Map(checkedValueMap));
  }, [defaultSelectFields]);

  var closeTag = function closeTag(id) {
    var _checkedValueMap$get;

    var restValue = (_checkedValueMap$get = checkedValueMap.get('single')) === null || _checkedValueMap$get === void 0 ? void 0 : _checkedValueMap$get.filter(function (item) {
      return !item.includes(id);
    });

    if (restValue !== null && restValue !== void 0 && restValue.length) {
      checkedValueMap.set('single', restValue);
    } else {
      checkedValueMap.delete('single');
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  var dropHandle = function dropHandle(item, index) {
    var temp = item.checkedValueMap.get('single') || [];
    checkedValueMap.set('single', moveTagItem(temp, item, index));
    setCheckedValueMap(new Map(checkedValueMap));
  };

  return /*#__PURE__*/React.createElement(DndProvider, {
    backend: HTML5Backend
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, selectAllFields === null || selectAllFields === void 0 ? void 0 : selectAllFields.map(function (item, index) {
    return /*#__PURE__*/React.createElement(TagItem, _extends({
      key: item === null || item === void 0 ? void 0 : item.fieldId
    }, item, {
      index: index,
      dropHandle: dropHandle,
      closeTag: closeTag
    }));
  })));
};