import React, { useMemo } from 'react';
import { useStoreContext } from "./useStoreContext";
import { Typography, Tag } from 'rlj-design';
var TextOverFlow = Typography.TextOverFlow;
export var useFieldsToOptions = function useFieldsToOptions(columns, groupOnChange) {
  var _useStoreContext = useStoreContext(),
      checkedValueMap = _useStoreContext.checkedValueMap;

  var options = useMemo(function () {
    if (!columns) return;
    return columns.map(function (item) {
      var fieldDisabled = item.fieldDisabled,
          value = item.fieldId,
          fieldName = item.fieldName,
          status = item.status,
          _item$checkable = item.checkable,
          checkable = _item$checkable === void 0 ? true : _item$checkable;
      var disabled = fieldDisabled || !checkable;
      var isRemove = status === 'remove';
      return {
        value: value,
        label: /*#__PURE__*/React.createElement("div", {
          style: {
            display: 'flex',
            alignItems: 'center'
          }
        }, /*#__PURE__*/React.createElement(TextOverFlow, {
          style: {
            display: 'block'
          },
          width: "unset",
          maxWidth: isRemove ? 55 : 100
        }, fieldName), isRemove && /*#__PURE__*/React.createElement(Tag, {
          style: {
            margin: '0 0 0 4px'
          },
          type: "disabled"
        }, "\u5DF2\u79FB\u9664")),
        disabled: disabled,
        onChange: groupOnChange
      };
    });
  }, [columns, checkedValueMap]);
  return options;
};