function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useRef, useContext, useState } from 'react';
import { Icon, Form, Button, Switch } from 'rlj-design';
import SortValue from "./SortValue";
import { useUpdateEffect } from 'ahooks';
import { DragDropContext, Droppable, Draggable } from 'react-beautiful-dnd';
import { SortContext } from "./Sort";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/sortContent.less";
var prefixCls = "".concat(PREFIX_CLS, "-sort-content");

var SortContent = function SortContent(props) {
  var sortTitle = props.sortTitle,
      sortSecondTitle = props.sortSecondTitle,
      showAutoSortButton = props.showAutoSortButton,
      isAutoSort = props.isAutoSort;
  var ref = useRef(null);

  var _Form$useFormInstance = Form.useFormInstance(),
      validateFields = _Form$useFormInstance.validateFields,
      getFieldsValue = _Form$useFormInstance.getFieldsValue,
      setFieldsValue = _Form$useFormInstance.setFieldsValue;

  var _ref = useContext(SortContext),
      setFields = _ref.setFields,
      fields = _ref.fields,
      ok = _ref.ok,
      setOpen = _ref.setOpen,
      onFinish = _ref.onFinish;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      fieldsList = _useState2[0],
      setFieldsList = _useState2[1];

  var _useState3 = useState(!!isAutoSort),
      _useState4 = _slicedToArray(_useState3, 2),
      autoSort = _useState4[0],
      setAutoSort = _useState4[1];

  useEffect(function () {
    if (fields !== null && fields !== void 0 && fields.length) {
      setFieldsList(fields.map(function (_, index) {
        return {
          name: index
        };
      }));
    } else {
      setFieldsList([{
        name: 0
      }]);
    }
  }, [fields]);
  useUpdateEffect(function () {
    return autoSort && ok();
  }, [fields]); // 数据元素交换位置

  var reorder = function reorder(list, startIndex, endIndex) {
    var result = Array.from(list);

    var _result$splice = result.splice(startIndex, 1),
        _result$splice2 = _slicedToArray(_result$splice, 1),
        removed = _result$splice2[0];

    result.splice(endIndex, 0, removed);
    return result;
  };

  var addNewItem = function addNewItem() {
    validateFields().then(function () {
      add();
    }).then(function () {
      try {
        var _ref$current;

        ref.current.scrollTop = ref === null || ref === void 0 ? void 0 : (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollHeight;
      } catch (error) {
        console.error(error);
      }
    }).catch(function (error) {
      console.error(error);
    });
  };

  var onDragEnd = function onDragEnd(result) {
    var _getFieldsValue;

    if (!result.destination || result.destination.index === result.source.index) {
      return;
    }

    var quotes = result ? reorder(fieldsList, result.source.index, result.destination.index) : fieldsList;
    var values = ((_getFieldsValue = getFieldsValue()) === null || _getFieldsValue === void 0 ? void 0 : _getFieldsValue.fields) || [];
    var data = result ? reorder(values, result.source.index, result.destination.index) : values;
    setFieldsList(quotes.map(function (_, index) {
      return {
        name: index
      };
    }));
    setFieldsValue({
      fields: data
    });
    setFields(data);
  };

  var getQuoteList = function getQuoteList() {
    return fieldsList.map(function (item, index) {
      return /*#__PURE__*/React.createElement(Draggable, {
        key: "id-".concat(index),
        draggableId: "id-".concat(index),
        index: index,
        style: {
          marginBottom: 12
        }
      }, function (provided) {
        return /*#__PURE__*/React.createElement("div", _extends({
          ref: provided.innerRef
        }, provided.draggableProps, provided.dragHandleProps), /*#__PURE__*/React.createElement(SortValue, {
          item: item,
          autoSort: autoSort,
          remove: remove
        }));
      });
    });
  };

  var add = function add() {
    var fieldsLength = (fieldsList === null || fieldsList === void 0 ? void 0 : fieldsList.length) || 0;
    setFieldsList(fieldsList.concat([{
      name: fieldsLength
    }]));
  };

  var remove = function remove(index) {
    var _getFieldsValue2;

    if ((fieldsList === null || fieldsList === void 0 ? void 0 : fieldsList.length) < 2) return;
    var newFieldsList = fieldsList.filter(function (_, i) {
      return i !== index;
    });
    var formValues = ((_getFieldsValue2 = getFieldsValue()) === null || _getFieldsValue2 === void 0 ? void 0 : _getFieldsValue2.fields) || [];
    var res = newFieldsList.map(function (item) {
      return formValues === null || formValues === void 0 ? void 0 : formValues[item.name];
    });
    setFieldsList(newFieldsList.map(function (_, index) {
      return {
        name: index
      };
    }));
    setFieldsValue({
      fields: res
    });
    setFields(res);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title")
  }, /*#__PURE__*/React.createElement("div", null, sortTitle, /*#__PURE__*/React.createElement("span", null, sortSecondTitle)), showAutoSortButton && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title-btn")
  }, /*#__PURE__*/React.createElement("span", null, "\u81EA\u52A8\u6392\u5E8F"), /*#__PURE__*/React.createElement(Switch, {
    size: "small",
    style: {
      marginLeft: 4,
      width: 28
    },
    onChange: setAutoSort
  }))), /*#__PURE__*/React.createElement(DragDropContext, {
    onDragEnd: onDragEnd
  }, /*#__PURE__*/React.createElement(Droppable, {
    droppableId: "list"
  }, function (provided) {
    return /*#__PURE__*/React.createElement("div", _extends({
      ref: provided.innerRef
    }, provided.droppableProps), /*#__PURE__*/React.createElement(Form.List, {
      name: "fields",
      initialValue: fields
    }, function () {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        ref: ref,
        className: "".concat(prefixCls, "-container")
      }, getQuoteList(), provided.placeholder), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-footer")
      }, /*#__PURE__*/React.createElement(Button, {
        onClick: addNewItem,
        type: "link",
        noPadding: true,
        disabled: (fields === null || fields === void 0 ? void 0 : fields.length) === 10
      }, /*#__PURE__*/React.createElement(Icon, {
        type: "add"
      }), "\u6DFB\u52A0\u6392\u5E8F\u6761\u4EF6"), !autoSort && /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, {
        type: "default",
        onClick: function onClick() {
          return setOpen(false);
        },
        style: {
          marginRight: 12
        }
      }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(Button, {
        type: "primary",
        onClick: function onClick() {
          return onFinish();
        }
      }, "\u5E94\u7528"))));
    }));
  })));
};

SortContent.defaultProps = {
  sortTitle: '排序',
  sortSecondTitle: '最多添加10个排序条件，排在前面优先级更高'
};
export default SortContent;