function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useContext, useEffect, useState } from 'react';
import Children from "./item";
import { getNormalDpi } from "../../utils/tools";
import "./index.less";
import { ExcelContext } from "../../index";
import { DataCompCxt } from "../index";
import { sumWidths } from "../../utils/tools";
import classnames from 'classnames';

// 构建表头, 需要显示的数据
var headerBuilder = function headerBuilder(minColumn, maxColumn, columnWidth, stickyHeight, noFixed, fixedLeft) {
  var fixedLeftLen = fixedLeft.data.length;
  var columns = [];
  var left = [0];
  var pos = 0;

  for (var c = 1; c <= maxColumn; c++) {
    pos += columnWidth(c - 1);
    left.push(pos);
  }

  for (var i = minColumn; i <= maxColumn; i++) {
    columns.push({
      style: {
        height: stickyHeight,
        width: columnWidth(i),
        left: left[i]
      },
      data: noFixed.data[i],
      index: fixedLeftLen + i
    });
  }

  return columns;
};

var dStyle = function dStyle(width, height) {
  var params = {};
  if (width) params.width = width;
  if (height) params.height = height;
  return params;
};

var StickyHeader = function StickyHeader(props) {
  var minColumn = props.minColumn,
      maxColumn = props.maxColumn;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isShow = _useState2[0],
      setIsShow = _useState2[1];

  var _ref = useContext(ExcelContext),
      columnInfo = _ref.columnInfo,
      summation = _ref.summation,
      gridRef = _ref.gridRef,
      colData = _ref.colData;

  var _ref2 = useContext(DataCompCxt),
      columnWidth = _ref2.columnWidth;

  var height = colData.defaultItemHeight;
  var noFixed = columnInfo.noFixed,
      fixedLeft = columnInfo.fixedLeft,
      fixedRight = columnInfo.fixedRight,
      summationHeight = columnInfo.summationHeight;
  var stickyWidthLeft = fixedLeft.res;
  var stickyWidthRight = fixedRight.res;
  var stickyHeight = summationHeight;
  useEffect(function () {
    if (summation !== null && summation !== void 0 && summation.show) {
      setTimeout(function () {
        setIsShow(true);
      }, 300);
    } else {
      setIsShow(false);
    }
  }, [summation]);
  var centerColumns = headerBuilder(minColumn, maxColumn, columnWidth, stickyHeight, noFixed, fixedLeft);

  var fn = function fn(m) {
    if (m.width) {
      return m.width;
    } else if (m.children) {
      return sumWidths(m.children.map(function (v) {
        return v.width || 0;
      }));
    } else {
      return 0;
    }
  };

  var isEndBottom = function () {
    var isShowDirScrollBar = columnInfo.isShowDirScrollBar,
        dataSourceHeightInfo = columnInfo.dataSourceHeightInfo,
        contHeight = columnInfo.contHeight;
    var len = sumWidths(dataSourceHeightInfo);
    var maxHeight = len * height;
    var scrollTop = maxHeight - contHeight;

    if (isShowDirScrollBar) {
      return gridRef.current && Math.abs(scrollTop - gridRef.current.state.scrollTop) < 2;
    } else {
      return true;
    }
  }();

  if (!isShow) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('salaryExcelSummationFooter', {
      isEndBottom: isEndBottom
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: "baseLeft",
    style: dStyle(stickyWidthLeft, stickyHeight)
  }, fixedLeft.data.map(function (v, index) {
    return /*#__PURE__*/React.createElement(Children, {
      key: index,
      index: index,
      style: dStyle(fn(v)),
      mainColumns: v,
      isFixCol: true
    });
  })), /*#__PURE__*/React.createElement("div", {
    className: "scrollable",
    style: dStyle(columnInfo.noFixed.res)
  }, centerColumns.map(function (_ref3, i) {
    var index = _ref3.index,
        data = _ref3.data,
        style = _ref3.style;
    return /*#__PURE__*/React.createElement("div", {
      className: "item",
      key: i,
      style: style
    }, /*#__PURE__*/React.createElement(Children, {
      key: data.dataIndex,
      index: index,
      style: dStyle(style.width),
      mainColumns: data
    }));
  })), /*#__PURE__*/React.createElement("div", {
    className: "baseRight",
    style: dStyle(stickyWidthRight - (getNormalDpi() ? 0 : 1), stickyHeight)
  }, fixedRight.data.map(function (v, index) {
    return /*#__PURE__*/React.createElement(Children, {
      key: index,
      index: index,
      style: dStyle(fn(v)),
      mainColumns: v,
      isFixCol: true
    });
  })));
};

export default StickyHeader;