import React, { useContext } from 'react';
import Crosshair from "./crosshair";
import { ExcelContext } from "../../index";
import "./index.less";
export default function SelectCell() {
  var _style$width, _style$height, _style$left, _style$top, _dataSource$length, _selectRow$rowIndex;

  var _ref = useContext(ExcelContext),
      selectRow = _ref.selectRow,
      editableConfig = _ref.editableConfig,
      dataSource = _ref.dataSource;

  var _ref2 = selectRow || {},
      _ref2$maxRowIndex = _ref2.maxRowIndex,
      maxRowIndex = _ref2$maxRowIndex === void 0 ? 0 : _ref2$maxRowIndex,
      _ref2$rowIndex = _ref2.rowIndex,
      rowIndex = _ref2$rowIndex === void 0 ? 0 : _ref2$rowIndex;

  var style = selectRow === null || selectRow === void 0 ? void 0 : selectRow.style;
  var width = (_style$width = style === null || style === void 0 ? void 0 : style.width) !== null && _style$width !== void 0 ? _style$width : 0;
  var height = (_style$height = style === null || style === void 0 ? void 0 : style.height) !== null && _style$height !== void 0 ? _style$height : 0;
  var left = (_style$left = style === null || style === void 0 ? void 0 : style.left) !== null && _style$left !== void 0 ? _style$left : 0;
  var top = (_style$top = style === null || style === void 0 ? void 0 : style.top) !== null && _style$top !== void 0 ? _style$top : 0;
  var sourceMaxIndex = ((_dataSource$length = dataSource === null || dataSource === void 0 ? void 0 : dataSource.length) !== null && _dataSource$length !== void 0 ? _dataSource$length : 1) - 1;
  var indexNotExceeded = ((_selectRow$rowIndex = selectRow === null || selectRow === void 0 ? void 0 : selectRow.rowIndex) !== null && _selectRow$rowIndex !== void 0 ? _selectRow$rowIndex : 0) < sourceMaxIndex;

  if (!(editableConfig !== null && editableConfig !== void 0 && editableConfig.editable) || !selectRow) {
    return null;
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "dataItemSelectTop",
    style: {
      width: width - 1,
      top: top,
      left: left
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "dataItemSelectBottom",
    style: {
      width: width - 1,
      top: top + height * (maxRowIndex - rowIndex + 1) - 3,
      left: left
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "dataItemSelectLeft",
    style: {
      height: height * (maxRowIndex - rowIndex + 1) - 1,
      top: top,
      left: left
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "dataItemSelectRight",
    style: {
      height: height * (maxRowIndex - rowIndex + 1) - 1,
      left: left + width - 3,
      top: top
    }
  }), indexNotExceeded && maxRowIndex === rowIndex && /*#__PURE__*/React.createElement(Crosshair, {
    currentColumn: selectRow.currentColumn,
    currentData: selectRow.currentData,
    rowIndex: selectRow.rowIndex,
    left: left + width - 3 - 5,
    top: top + height - 3 - 5,
    width: width
  }));
}